<template>
  <div class="row justify-content-center img-bg">
    <div class="absolute row">
      <div class="col-2"></div>
      <div class="col-8 row main-contain auth-custom-contain">
        <div
          class="col-7 left-contain-on-border bg-white text-center overflow-main-contain scrollbar"
        >
          <div class="space-2" />
          <h1 class="t-color-red">{{title1}}</h1>
          <div class="space-1" />
          <p class="t-color-soft-gray">
            {{dialog1}}
            <br />
            {{dialog2}}
          </p>
          <div class="space-2" />
          <div class="row">
            <div class="col-2" />
            <div class="col-8">
              <form>
                <div class="group">
                  <input type="text" v-model="email" required="required" />
                  <span class="bar"></span>
                  <label>{{text1}}</label>
                  <div class="row absolute">
                    <h6 v-if="email === ''" class="t-validate-div t-color-red col-12 right">
                      <i class="fa fa-exclamation-circle" /> Email is required
                    </h6>
                    <h6
                      v-if="(email !=='') && (!reg.test(email))"
                      class="t-validate-div t-color-red col-12 right"
                    >
                      <i class="fa fa-times-circle" /> Please Enter Correct Email
                    </h6>
                  </div>
                </div>
                <botton class="btn" v-on:click="forgotpass" v-if="btnShow === 1"><h6 style="margin-bottom: 0rem;">{{text2}}</h6></botton>
                <botton class="btn disable" v-if="btnShow === 0" style="min-height: 31px; max-height: 31px;"><b-spinner style="top: 97px;position: absolute;left: 11vw;" small/></botton>
              </form>
              <div class="space-2" />
              <h6 class="t-color-soft-gray">
                {{text3}}
                <router-link to="/signin" class="link">{{text4}}</router-link>
              </h6>
            </div>
            <div class="col-2" />
          </div>
        </div>
        <div class="col-5 right-contain-on-border img-auth-bg"></div>
      </div>
    </div>
    <b-alert
      :show="dismissCountDown"
      variant="light"
      @dismissed="dismissCountDown=0"
      @dismiss-count-down="countDownChanged"
      fade
      style="position: absolute;top: 1px;width: auto;"
    >
    {{massage}}
    </b-alert>
  </div>
</template>

<script>
export default {
  mounted () {
    if (this.btnShow === 1) {
      this.showBtn()
    } else {
      this.hideBtn()
    }
    console.log('Component mounted.')
  },
  data () {
    return {
      title1: 'Forgot password',
      dialog1: 'Please enter your email address or username.',
      dialog2: 'You will receive a link to create a new password via email.',
      text1: 'Email',
      text2: 'SEND',
      text3: 'return to',
      text4: 'Sing in',
      email: '',
      massage: '',
      dismissSecs: 5,
      dismissCountDown: 0,
      isValidationAllowed: false,
      btnShow: 1,
      reg: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/
    }
  },
  methods: {
    forgotpass () {
      this.hideBtn()
      this.axios
        .post('http://127.0.0.1:8000/api/sendReqRePass', {
          email: this.email
        })
        .then(response => {
          this.$router.push('/repass/' + this.email)
          console.log(response)
        })
        .catch(error => {
          this.showBtn()
          console.log(error)
          if (this.email) {
            this.showAlertError()
          } else {
            this.showAlertEnter()
          }
        })
    },
    countDownChanged (dismissCountDown) {
      this.dismissCountDown = dismissCountDown
    },
    showAlertError () {
      this.massage = ''
      this.massage = 'Your email is wrong'
      this.dismissCountDown = this.dismissSecs
    },
    showAlertEnter () {
      this.massage = ''
      this.massage = 'Please enter your email'
      this.dismissCountDown = this.dismissSecs
    },
    hideBtn () {
      this.btnShow = 0
    },
    showBtn () {
      this.btnShow = 1
    }
  }
}
</script>
